:
eval 'exec perl -w -S $0 ${1+"$@"}'
 if 0;
#
#    Copyright (C) 2004,2005,2006 Patrick Blackburn & Johan Bos
#
#    This file is part of BB1, version 1.3 (November 2006).
#
#    BB1 is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    BB1 is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with BB1; if not, write to the Free Software Foundation, Inc., 
#    59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#

# parameterisation of the programs
my $path = $ARGV[0];
chomp $path;
my $domainsize = $ARGV[1];
my $pleaseload = $ARGV[2];

print "path: ".$path;

# where to store results
my $model = "";
my $winner = "";

# how to run programs
my %command = (
otter   => "otter < ".$path."/otter.in > ".$path."/otter.out",
#mace    => "mace2 -t20 -n1 -N$domainsize -P < ".$path."/mace.in > ".$path."/mace.out",
 mace    => "mace2 -t30 -n1 -N$domainsize -P < ".$path."/mace.in > ".$path."/mace.out",
);

foreach my $p (("otter", "mace")) {
   if ($pleaseload =~ /$p/) {
          # the child process execs the program
          system($command{$p}); 
      }
   }

      my $readmacemodel = 0;
      open(OUTPUT,$path."/mace.out");
      while (<OUTPUT>) {
             if (/end_of_model/) {
                $winner = "mace";
                $readmacemodel = 0;
             }
             elsif ($readmacemodel) {
                $model = "$model$_";
                $model =~ s/\$(.*?)\,/$1\,/;
             }
             elsif (/======================= Model/) {
                $readmacemodel = 1;
	    }
      }
      close(OUTPUT);
   


      open(OUTPUT,$path."/otter.out");
      while (<OUTPUT>) {
             if (/proof of the theorem/) {
             	if($winner ne ""){$winner="maceotter"}else{
                $winner = "otter";}
            }
     }
     close(OUTPUT);
     



open(OUTPUT, ">".$path."/tpmb.out");
if ($winner ne "") {
   my $details = "proof.\n";
   if ($model ne "") {
      $details = $model;
   }
   print OUTPUT $details;
   print OUTPUT "engine($winner).\n";
}
else {
   print OUTPUT "unknown.\n";
}
close(OUTPUT);

exit 0;

